import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { MerchantGoodsPackage, MerchantGoodsPackageParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商家充值套餐
 */
export async function pageMerchantGoodsPackage(params: MerchantGoodsPackageParam) {
  const res = await request.get<ApiResult<PageResult<MerchantGoodsPackage>>>(
    MODULES_API_URL + '/shop/merchant-goods-package/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商家充值套餐列表
 */
export async function listMerchantGoodsPackage(params?: MerchantGoodsPackageParam) {
  const res = await request.get<ApiResult<MerchantGoodsPackage[]>>(
    MODULES_API_URL + '/shop/merchant-goods-package',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商家充值套餐
 */
export async function addMerchantGoodsPackage(data: MerchantGoodsPackage) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-goods-package',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商家充值套餐
 */
export async function updateMerchantGoodsPackage(data: MerchantGoodsPackage) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-goods-package',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商家充值套餐
 */
export async function removeMerchantGoodsPackage(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-goods-package/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商家充值套餐
 */
export async function removeBatchMerchantGoodsPackage(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-goods-package/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商家充值套餐
 */
export async function getMerchantGoodsPackage(id: number) {
  const res = await request.get<ApiResult<MerchantGoodsPackage>>(
    MODULES_API_URL + '/shop/merchant-goods-package/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
